#include <velib/base/base.h>
#include <velib/base/ve_string.h>

#ifdef _MSC_VER
// MSCV secure versions (_s)
size_t ve_strcat(char* dest, size_t size, char const*src)
{
	strcat_s(dest,size,src);
	return strlen(dest);
}
size_t ve_strcpy(char* dest, size_t size, char const*src)
{
	strcpy_s(dest, size, src);
	return strlen(dest);
}

int ve_vsnprintf(char *outBuf, size_t size, const char *format, va_list ap)
{
	int count = -1;

	if (size != 0 && outBuf != NULL)
		count = _vsnprintf_s(outBuf, size, _TRUNCATE, format, ap);
	if (count == -1)
		count = _vscprintf(format, ap);

	return count;
}

int ve_snprintf(char *outBuf, size_t size, const char *format, ...)
{
	int count;
	va_list ap;

	va_start(ap, format);
	count = ve_vsnprintf(outBuf, size, format, ap);
	va_end(ap);

	return count;
}

#elif defined(_UNIX_) || defined(__GNUC__)

// todo: check size
// todo: added __GNUC__ for MinGW (not checked though)
size_t ve_strcat(char* dest, size_t size, char const*src)
{
	VE_UNUSED(size);

	strcat(dest, src);
	return strlen(dest);
}

size_t ve_strcpy(char* dest, size_t size, char const*src)
{
	VE_UNUSED(size);

	strcpy(dest, src);
	return strlen(dest);
}

#endif

/* For platforms that do not have stricmp or a 'special' one */
#if BASE_COMPILER_CUSTOM_STRICMP
# ifndef ve_stricmp /* Could also be a macro */

int ve_stricmp(const char *s1, const char *s2)
{
	while (*s1 && (tolower(*s1) == tolower(*s2)))
		s1++, s2++;
	return tolower(*s1) - tolower(*s2);
}

# endif
#endif
