#include <stdio.h>

#include <velib/base/base.h>
#include <velib/canhw/canhw_console.h>
#include <velib/canhw/canhw_driver.h>
#include <velib/canhw/canhw.h>
#include <velib/platform/console.h>
#include <velib/platform/plt.h>
#include <velib/platform/task.h>
#include <velib/utils/ve_logger.h>


/**
 * Rather little needs to be done to make a general candump utility,
 * for all supported CAN bus interface. The CAN bus has already been setup by
 * the task and an option to dump frames is already inside the library.
 */

void j1939RxFree(J1939Msg *msg)
{
	switch (msg->type.p.kind)
	{
	case J1939_SF:
		j1939SfRxFree( (J1939Sf*) msg);
		break;

	case N2K_FP:
		n2kFpRxFree( (N2kFp*) msg);
		break;

	default:
		break;
	}
}

void taskInit(void)
{
	veCanShowTrace(veTrue);
	pltInterruptEnable();
}

/**
 * Just reading will show the messages.
 * The functions returns so the process goes to sleep, waiting for an CAN event.
 */
void taskUpdate(void)
{
	J1939Msg* msg;
	while ( (msg = veCanReadN2k()) )
		j1939RxFree(msg);
}

void taskTick(void)
{
}

#if 0
veBool veCanRxEvent(void)
{
	return veTrue;
}
#endif

